// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

/**
 ** \file /builddir/build/BUILD/xyce/build/src/UtilityPKG/ExpressionSrc/ExpressionParser.hxx
 ** Define the XyceExpression::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

#ifndef YY_XYCEEXPRESSION_BUILDDIR_BUILD_BUILD_XYCE_BUILD_SRC_UTILITYPKG_EXPRESSIONSRC_EXPRESSIONPARSER_HXX_INCLUDED
# define YY_XYCEEXPRESSION_BUILDDIR_BUILD_BUILD_XYCE_BUILD_SRC_UTILITYPKG_EXPRESSIONSRC_EXPRESSIONPARSER_HXX_INCLUDED


# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>
# include "stack.hh"
# include "location.hh"

#ifndef YYASSERT
# include <cassert>
# define YYASSERT assert
#endif


#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* Debug traces.  */
#ifndef XYCEEXPRESSIONDEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define XYCEEXPRESSIONDEBUG 1
#  else
#   define XYCEEXPRESSIONDEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define XYCEEXPRESSIONDEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined XYCEEXPRESSIONDEBUG */


namespace XyceExpression {
#line 127 "/builddir/build/BUILD/xyce/build/src/UtilityPKG/ExpressionSrc/ExpressionParser.hxx" // lalr1.cc:377



  /// A char[S] buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current state.
  template <size_t S>
  struct variant
  {
    /// Type of *this.
    typedef variant<S> self_type;

    /// Empty construction.
    variant ()
    {}

    /// Construct and fill.
    template <typename T>
    variant (const T& t)
    {
      YYASSERT (sizeof (T) <= S);
      new (yyas_<T> ()) T (t);
    }

    /// Destruction, allowed only if empty.
    ~variant ()
    {}

    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    build ()
    {
      return *new (yyas_<T> ()) T;
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    build (const T& t)
    {
      return *new (yyas_<T> ()) T (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as ()
    {
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const
    {
      return *yyas_<T> ();
    }

    /// Swap the content with \a other, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsability.
    /// Swapping between built and (possibly) non-built is done with
    /// variant::move ().
    template <typename T>
    void
    swap (self_type& other)
    {
      std::swap (as<T> (), other.as<T> ());
    }

    /// Move the content of \a other to this.
    ///
    /// Destroys \a other.
    template <typename T>
    void
    move (self_type& other)
    {
      build<T> ();
      swap<T> (other);
      other.destroy<T> ();
    }

    /// Copy the content of \a other to this.
    template <typename T>
    void
    copy (const self_type& other)
    {
      build<T> (other.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
    }

  private:
    /// Prohibit blind copies.
    self_type& operator=(const self_type&);
    variant (const self_type&);

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ ()
    {
      void *yyp = yybuffer_.yyraw;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const
    {
      const void *yyp = yybuffer_.yyraw;
      return static_cast<const T*> (yyp);
     }

    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me;
      /// A buffer large enough to store any of the semantic values.
      char yyraw[S];
    } yybuffer_;
  };


  /// A Bison parser.
  class ExpressionParser
  {
  public:
#ifndef XYCEEXPRESSIONSTYPE
    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // expression
      // exp
      // polyarg
      char dummy1[sizeof(Teuchos::RCP<astNode<usedType> > )];

      // table_threeOrFourArgs
      // table2_threeOrFourArgs
      // table3_threeOrFourArgs
      char dummy2[sizeof(Xyce::Util::tableArgs<usedType> )];

      // "polysize"
      // "polycoef"
      // "num"
      // "imag_num"
      // paren_polycoef
      char dummy3[sizeof(double)];

      // "rf_param_arg"
      char dummy4[sizeof(int)];

      // polypair
      char dummy5[sizeof(std::pair<double, std::vector< Teuchos::RCP<astNode<usedType> > > > *)];

      // "word"
      // "filename"
      // "function"
      // "lead"
      // "onoise"
      // "inoise"
      // "power"
      // "voltage"
      // "voltagenode"
      // "poly_voltage"
      // "current"
      // "currentdevice"
      // "poly_current"
      // "poly_word"
      // "internal_variable"
      // "internal_variable_device"
      // "noise"
      // "noise_device_variable"
      // "rfparam"
      // "table"
      // "table2"
      // "table3"
      // "tablefile"
      // paren_polyword
      char dummy6[sizeof(std::string *)];

      // nonempty_func_arglist
      // nonempty_func_arglist2
      // two_or_more_arglist
      // nonempty_arg_pairs
      char dummy7[sizeof(std::vector< Teuchos::RCP<astNode<usedType> > > *)];

      // nonempty_rfparam_arg_list
      char dummy8[sizeof(std::vector<int> *)];

      // nonempty_noise_device_list
      // nonempty_voltagenodelist
      char dummy9[sizeof(std::vector<std::string> *)];
};

    /// Symbol semantic values.
    typedef variant<sizeof(union_type)> semantic_type;
#else
    typedef XYCEEXPRESSIONSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m);
      location_type location;
    };

    /// Tokens.
    struct token
    {
      enum yytokentype
      {
        TOK_POLYSIZE = 258,
        TOK_POLYCOEF = 259,
        TOK_NUM = 260,
        TOK_IMAG_NUM = 261,
        TOK_WORD = 262,
        TOK_FILENAME = 263,
        TOK_FUNCTION = 264,
        TOK_LEAD = 265,
        TOK_ONOISE = 266,
        TOK_INOISE = 267,
        TOK_POWER = 268,
        TOK_VOLTAGE = 269,
        TOK_VOLTAGENODE = 270,
        TOK_POLY_VOLTAGE = 271,
        TOK_CURRENT = 272,
        TOK_CURRENTDEV = 273,
        TOK_POLY_CURRENT = 274,
        TOK_POLY_WORD = 275,
        TOK_INTERNAL_VAR = 276,
        TOK_INTERNAL_VAR_DEV = 277,
        TOK_NOISE = 278,
        TOK_NOISE_DEV_VAR = 279,
        TOK_RFPARAM = 280,
        TOK_RFPARAM_ARG = 281,
        TOK_TABLE = 282,
        TOK_TABLE2 = 283,
        TOK_TABLE3 = 284,
        TOK_TABLEFILE = 285,
        TOK_SQRT = 286,
        TOK_MAX = 287,
        TOK_MIN = 288,
        TOK_PHASE = 289,
        TOK_REAL = 290,
        TOK_IMAG = 291,
        TOK_DB = 292,
        TOK_EXP = 293,
        TOK_EXP_CONST = 294,
        TOK_SIN = 295,
        TOK_COS = 296,
        TOK_MABS = 297,
        TOK_ABS = 298,
        TOK_ACOS = 299,
        TOK_ACOSH = 300,
        TOK_ASIN = 301,
        TOK_ASINH = 302,
        TOK_ATAN2 = 303,
        TOK_ATAN = 304,
        TOK_ATANH = 305,
        TOK_COSH = 306,
        TOK_LN = 307,
        TOK_LOG = 308,
        TOK_LOG10 = 309,
        TOK_SINH = 310,
        TOK_TAN = 311,
        TOK_TANH = 312,
        TOK_IF = 313,
        TOK_EQUALS = 314,
        TOK_SEMICOLON = 315,
        TOK_AUNIF = 316,
        TOK_UNIF = 317,
        TOK_AGAUSS = 318,
        TOK_FMOD = 319,
        TOK_NINT = 320,
        TOK_CEIL = 321,
        TOK_GAUSS = 322,
        TOK_DDT = 323,
        TOK_DDX = 324,
        TOK_FLOOR = 325,
        TOK_INT = 326,
        TOK_LIMIT = 327,
        TOK_POWSFUNC = 328,
        TOK_RAND = 329,
        TOK_SDT = 330,
        TOK_SGN = 331,
        TOK_SIGN = 332,
        TOK_STP = 333,
        TOK_TABLEFILE_END = 334,
        TOK_SCHEDULE = 335,
        TOK_URAMP = 336,
        TOK_BADPOLY = 337,
        TOK_SPICE_PULSE = 338,
        TOK_SPICE_SIN = 339,
        TOK_SPICE_EXP = 340,
        TOK_SPICE_SFFM = 341,
        TOK_DT = 342,
        TOK_TIME = 343,
        TOK_TEMP = 344,
        TOK_VT = 345,
        TOK_FREQ = 346,
        TOK_GMIN = 347,
        TOK_PI = 348,
        TOK_C_TO_K = 349,
        TOK_RIGHTPAREN = 350,
        TOK_LEFTPAREN = 351,
        TOK_RIGHTCURLYBRACE = 352,
        TOK_LEFTCURLYBRACE = 353,
        TOK_COMMA = 354,
        TOK_QUESTION_MARK = 356,
        TOK_COLON = 358,
        TOK_OR = 360,
        TOK_AND = 362,
        TOK_NOT = 364,
        TOK_CARET = 366,
        TOK_EQ = 368,
        TOK_NE = 370,
        TOK_LE = 372,
        TOK_LT = 374,
        TOK_GE = 376,
        TOK_GT = 378,
        TOK_INVALID_OP = 380,
        TOK_MINUS = 381,
        TOK_PLUS = 383,
        TOK_MOD = 385,
        TOK_MULTIPLY = 387,
        TOK_DIVIDE = 389,
        NEG = 391,
        TOK_POW = 392,
        TOK_POWFUNC = 393
      };
    };

    /// (External) token type, as returned by yylex.
    typedef token::yytokentype token_type;

    /// Symbol type: an internal symbol number.
    typedef int symbol_number_type;

    /// The symbol type number to denote an empty symbol.
    enum { empty_symbol = -2 };

    /// Internal symbol number for tokens (subsumed by symbol_number_type).
    typedef unsigned char token_number_type;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol type
    /// via type_get().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ();

      /// Copy constructor.
      basic_symbol (const basic_symbol& other);

      /// Constructor for valueless symbols, and symbols from each type.

  basic_symbol (typename Base::kind_type t, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Teuchos::RCP<astNode<usedType> >  v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Xyce::Util::tableArgs<usedType>  v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const double v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const int v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::pair<double, std::vector< Teuchos::RCP<astNode<usedType> > > > * v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::string * v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector< Teuchos::RCP<astNode<usedType> > > * v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<int> * v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<std::string> * v, const location_type& l);


      /// Constructor for symbols with semantic value.
      basic_symbol (typename Base::kind_type t,
                    const semantic_type& v,
                    const location_type& l);

      /// Destroy the symbol.
      ~basic_symbol ();

      /// Destroy contents, and record that is empty.
      void clear ();

      /// Whether empty.
      bool empty () const;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;

    private:
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& other);
    };

    /// Type access provider for token (enum) based symbols.
    struct by_type
    {
      /// Default constructor.
      by_type ();

      /// Copy constructor.
      by_type (const by_type& other);

      /// The symbol type as needed by the constructor.
      typedef token_type kind_type;

      /// Constructor from (external) token numbers.
      by_type (kind_type t);

      /// Record that this symbol is empty.
      void clear ();

      /// Steal the symbol type from \a that.
      void move (by_type& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_number_type type_get () const;

      /// The token.
      token_type token () const;

      /// The symbol type.
      /// \a empty_symbol when empty.
      /// An int, not token_number_type, to be able to store empty_symbol.
      int type;
    };

    /// "External" symbols: returned by the scanner.
    typedef basic_symbol<by_type> symbol_type;

    // Symbol constructors declarations.
    static inline
    symbol_type
    make_TOK_POLYSIZE (const double& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_POLYCOEF (const double& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_NUM (const double& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_IMAG_NUM (const double& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_WORD (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_FILENAME (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_FUNCTION (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_LEAD (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_ONOISE (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_INOISE (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_POWER (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_VOLTAGE (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_VOLTAGENODE (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_POLY_VOLTAGE (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_CURRENT (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_CURRENTDEV (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_POLY_CURRENT (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_POLY_WORD (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_INTERNAL_VAR (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_INTERNAL_VAR_DEV (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_NOISE (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_NOISE_DEV_VAR (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_RFPARAM (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_RFPARAM_ARG (const int& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_TABLE (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_TABLE2 (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_TABLE3 (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_TABLEFILE (const std::string *& v, const location_type& l);

    static inline
    symbol_type
    make_TOK_SQRT (const location_type& l);

    static inline
    symbol_type
    make_TOK_MAX (const location_type& l);

    static inline
    symbol_type
    make_TOK_MIN (const location_type& l);

    static inline
    symbol_type
    make_TOK_PHASE (const location_type& l);

    static inline
    symbol_type
    make_TOK_REAL (const location_type& l);

    static inline
    symbol_type
    make_TOK_IMAG (const location_type& l);

    static inline
    symbol_type
    make_TOK_DB (const location_type& l);

    static inline
    symbol_type
    make_TOK_EXP (const location_type& l);

    static inline
    symbol_type
    make_TOK_EXP_CONST (const location_type& l);

    static inline
    symbol_type
    make_TOK_SIN (const location_type& l);

    static inline
    symbol_type
    make_TOK_COS (const location_type& l);

    static inline
    symbol_type
    make_TOK_MABS (const location_type& l);

    static inline
    symbol_type
    make_TOK_ABS (const location_type& l);

    static inline
    symbol_type
    make_TOK_ACOS (const location_type& l);

    static inline
    symbol_type
    make_TOK_ACOSH (const location_type& l);

    static inline
    symbol_type
    make_TOK_ASIN (const location_type& l);

    static inline
    symbol_type
    make_TOK_ASINH (const location_type& l);

    static inline
    symbol_type
    make_TOK_ATAN2 (const location_type& l);

    static inline
    symbol_type
    make_TOK_ATAN (const location_type& l);

    static inline
    symbol_type
    make_TOK_ATANH (const location_type& l);

    static inline
    symbol_type
    make_TOK_COSH (const location_type& l);

    static inline
    symbol_type
    make_TOK_LN (const location_type& l);

    static inline
    symbol_type
    make_TOK_LOG (const location_type& l);

    static inline
    symbol_type
    make_TOK_LOG10 (const location_type& l);

    static inline
    symbol_type
    make_TOK_SINH (const location_type& l);

    static inline
    symbol_type
    make_TOK_TAN (const location_type& l);

    static inline
    symbol_type
    make_TOK_TANH (const location_type& l);

    static inline
    symbol_type
    make_TOK_IF (const location_type& l);

    static inline
    symbol_type
    make_TOK_EQUALS (const location_type& l);

    static inline
    symbol_type
    make_TOK_SEMICOLON (const location_type& l);

    static inline
    symbol_type
    make_TOK_AUNIF (const location_type& l);

    static inline
    symbol_type
    make_TOK_UNIF (const location_type& l);

    static inline
    symbol_type
    make_TOK_AGAUSS (const location_type& l);

    static inline
    symbol_type
    make_TOK_FMOD (const location_type& l);

    static inline
    symbol_type
    make_TOK_NINT (const location_type& l);

    static inline
    symbol_type
    make_TOK_CEIL (const location_type& l);

    static inline
    symbol_type
    make_TOK_GAUSS (const location_type& l);

    static inline
    symbol_type
    make_TOK_DDT (const location_type& l);

    static inline
    symbol_type
    make_TOK_DDX (const location_type& l);

    static inline
    symbol_type
    make_TOK_FLOOR (const location_type& l);

    static inline
    symbol_type
    make_TOK_INT (const location_type& l);

    static inline
    symbol_type
    make_TOK_LIMIT (const location_type& l);

    static inline
    symbol_type
    make_TOK_POWSFUNC (const location_type& l);

    static inline
    symbol_type
    make_TOK_RAND (const location_type& l);

    static inline
    symbol_type
    make_TOK_SDT (const location_type& l);

    static inline
    symbol_type
    make_TOK_SGN (const location_type& l);

    static inline
    symbol_type
    make_TOK_SIGN (const location_type& l);

    static inline
    symbol_type
    make_TOK_STP (const location_type& l);

    static inline
    symbol_type
    make_TOK_TABLEFILE_END (const location_type& l);

    static inline
    symbol_type
    make_TOK_SCHEDULE (const location_type& l);

    static inline
    symbol_type
    make_TOK_URAMP (const location_type& l);

    static inline
    symbol_type
    make_TOK_BADPOLY (const location_type& l);

    static inline
    symbol_type
    make_TOK_SPICE_PULSE (const location_type& l);

    static inline
    symbol_type
    make_TOK_SPICE_SIN (const location_type& l);

    static inline
    symbol_type
    make_TOK_SPICE_EXP (const location_type& l);

    static inline
    symbol_type
    make_TOK_SPICE_SFFM (const location_type& l);

    static inline
    symbol_type
    make_TOK_DT (const location_type& l);

    static inline
    symbol_type
    make_TOK_TIME (const location_type& l);

    static inline
    symbol_type
    make_TOK_TEMP (const location_type& l);

    static inline
    symbol_type
    make_TOK_VT (const location_type& l);

    static inline
    symbol_type
    make_TOK_FREQ (const location_type& l);

    static inline
    symbol_type
    make_TOK_GMIN (const location_type& l);

    static inline
    symbol_type
    make_TOK_PI (const location_type& l);

    static inline
    symbol_type
    make_TOK_C_TO_K (const location_type& l);

    static inline
    symbol_type
    make_TOK_RIGHTPAREN (const location_type& l);

    static inline
    symbol_type
    make_TOK_LEFTPAREN (const location_type& l);

    static inline
    symbol_type
    make_TOK_RIGHTCURLYBRACE (const location_type& l);

    static inline
    symbol_type
    make_TOK_LEFTCURLYBRACE (const location_type& l);

    static inline
    symbol_type
    make_TOK_COMMA (const location_type& l);

    static inline
    symbol_type
    make_TOK_QUESTION_MARK (const location_type& l);

    static inline
    symbol_type
    make_TOK_COLON (const location_type& l);

    static inline
    symbol_type
    make_TOK_OR (const location_type& l);

    static inline
    symbol_type
    make_TOK_AND (const location_type& l);

    static inline
    symbol_type
    make_TOK_NOT (const location_type& l);

    static inline
    symbol_type
    make_TOK_CARET (const location_type& l);

    static inline
    symbol_type
    make_TOK_EQ (const location_type& l);

    static inline
    symbol_type
    make_TOK_NE (const location_type& l);

    static inline
    symbol_type
    make_TOK_LE (const location_type& l);

    static inline
    symbol_type
    make_TOK_LT (const location_type& l);

    static inline
    symbol_type
    make_TOK_GE (const location_type& l);

    static inline
    symbol_type
    make_TOK_GT (const location_type& l);

    static inline
    symbol_type
    make_TOK_INVALID_OP (const location_type& l);

    static inline
    symbol_type
    make_TOK_MINUS (const location_type& l);

    static inline
    symbol_type
    make_TOK_PLUS (const location_type& l);

    static inline
    symbol_type
    make_TOK_MOD (const location_type& l);

    static inline
    symbol_type
    make_TOK_MULTIPLY (const location_type& l);

    static inline
    symbol_type
    make_TOK_DIVIDE (const location_type& l);

    static inline
    symbol_type
    make_NEG (const location_type& l);

    static inline
    symbol_type
    make_TOK_POW (const location_type& l);

    static inline
    symbol_type
    make_TOK_POWFUNC (const location_type& l);


    /// Build a parser object.
    ExpressionParser (Xyce::Util::ExpressionLexer *theLexer_yyarg, Xyce::Util::newExpression & newExp_yyarg);
    virtual ~ExpressionParser ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if XYCEEXPRESSIONDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

  private:
    /// This class is not copyable.
    ExpressionParser (const ExpressionParser&);
    ExpressionParser& operator= (const ExpressionParser&);

    /// State numbers.
    typedef int state_type;

    /// Generate an error message.
    /// \param yystate   the state where the error occurred.
    /// \param yyla      the lookahead token.
    virtual std::string yysyntax_error_ (state_type yystate,
                                         const symbol_type& yyla) const;

    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    static const signed char yypact_ninf_;
    static const signed char yytable_ninf_;

    /// Convert a scanner token number \a t to a symbol number.
    static token_number_type yytranslate_ (int t);

    // Tables.
  // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
  // STATE-NUM.
  static const short int yypact_[];

  // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
  // Performed when YYTABLE does not specify something else to do.  Zero
  // means the default is an error.
  static const unsigned char yydefact_[];

  // YYPGOTO[NTERM-NUM].
  static const short int yypgoto_[];

  // YYDEFGOTO[NTERM-NUM].
  static const short int yydefgoto_[];

  // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
  // positive, shift that token.  If negative, reduce the rule whose
  // number is the opposite.  If YYTABLE_NINF, syntax error.
  static const unsigned short int yytable_[];

  static const short int yycheck_[];

  // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
  // symbol of state STATE-NUM.
  static const unsigned char yystos_[];

  // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
  static const unsigned char yyr1_[];

  // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
  static const unsigned char yyr2_[];


#if XYCEEXPRESSIONDEBUG
    /// For a symbol, its name in clear.
    static const char* const yytname_[];

  // YYRLINE[YYN] -- Source line where rule number YYN was defined.
  static const unsigned short int yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r);
    /// Print the state stack on the debug stream.
    virtual void yystack_print_ ();

    // Debugging.
    int yydebug_;
    std::ostream* yycdebug_;

    /// \brief Display a symbol type, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state ();

      /// The symbol type as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s);

      /// Copy constructor.
      by_state (const by_state& other);

      /// Record that this symbol is empty.
      void clear ();

      /// Steal the symbol type from \a that.
      void move (by_state& that);

      /// The (internal) type number (corresponding to \a state).
      /// \a empty_symbol when empty.
      symbol_number_type type_get () const;

      /// The state number used to denote an empty symbol.
      enum { empty_state = -1 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, symbol_type& sym);
      /// Assignment, needed by push_back.
      stack_symbol_type& operator= (const stack_symbol_type& that);
    };

    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, stack_symbol_type& s);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, state_type s, symbol_type& sym);

    /// Pop \a n symbols the three stacks.
    void yypop_ (unsigned int n = 1);

    /// Constants.
    enum
    {
      yyeof_ = 0,
      yylast_ = 3087,     ///< Last index in yytable_.
      yynnts_ = 17,  ///< Number of nonterminal symbols.
      yyfinal_ = 175, ///< Termination state number.
      yyterror_ = 1,
      yyerrcode_ = 256,
      yyntokens_ = 139  ///< Number of tokens.
    };


    // User arguments.
    Xyce::Util::ExpressionLexer *theLexer;
    Xyce::Util::newExpression & newExp;
  };



} // XyceExpression
#line 1288 "/builddir/build/BUILD/xyce/build/src/UtilityPKG/ExpressionSrc/ExpressionParser.hxx" // lalr1.cc:377




#endif // !YY_XYCEEXPRESSION_BUILDDIR_BUILD_BUILD_XYCE_BUILD_SRC_UTILITYPKG_EXPRESSIONSRC_EXPRESSIONPARSER_HXX_INCLUDED
